'use strict';

var funcs = [{
    title: '`countPrimeFactors(n)`',
    topic: 'math',
    description: 'A function to count all prime factors of a given number.',
    return_type: 'number'
}, {
    title: '`factorialRecursive(n)`',
    topic: 'math',
    description: 'Print factorial of a number using recursive function approach.',
    return_type: 'number'
}, {
    title: '`factorialIterative(n)`',
    topic: 'math',
    description: 'Print factorial of a number using iterative approach.',
    return_type: 'number'
}, {
    title: '`factorialOneLine(n)`',
    topic: 'math',
    description: 'Print factorial of a number using a ternary operator.',
    return_type: 'number'
}, {
    title: '`doublefactorial(n)`',
    topic: 'math',
    description: 'Print semi-factorial or double factorial of number using the iterative approach.',
    return_type: 'number'
}, {
    title: '`factCountTrailingZeroes(n)`',
    topic: 'math',
    description: 'Print the count of trailing zeroes in n!.',
    return_type: 'number'
}, {
    title: '`fibRecursion(n)`',
    topic: 'math',
    description: 'Print nth fibonacci number using recursion.',
    return_type: 'number'
}, {
    title: '`fibDynamic(n)`',
    topic: 'math',
    description: 'Print nth fibonacci number using dynamic programming approach.',
    return_type: 'number'
}, {
    title: '`fisherYates(arr)`',
    topic: 'math',
    description: 'Shuffle an array using the Fisher Yates Algorithm using a while loop.',
    return_type: 'array'
}, {
    title: '`gcd(numb1, numb2)`',
    topic: 'math',
    description: 'Calculate the greatest common divisor among the two numbers using Euclideans algorithm.',
    return_type: 'number'
}, {
    title: '`maxOrMin(arr, task)`',
    topic: 'math',
    description: 'Get maximum or minimum of an array',
    return_type: 'number'
}, {
    title: '`pythagorasDistance(arg1, arg2)`',
    topic: 'math',
    description: 'Calculate the pythogorean distance if arg1 and arg2 are 2 sides of a right-angled triangle',
    return_type: 'number'
}, {
    title: '`isASCII(str)`',
    topic: 'validation',
    description: 'String contains ASCII characters',
    return_type: 'boolean'
}, {
    title: '`isBool(str)`',
    topic: 'validation',
    description: 'String contains true or false',
    return_type: 'boolean'
}, {
    title: '`isDataURI(str)`',
    topic: 'validation',
    description: 'String is a data uri format.',
    return_type: 'boolean'
}, {
    title: '`isEmpty(str)`',
    topic: 'validation',
    description: 'String is empty.',
    return_type: 'boolean'
}, {
    title: '`isEndWith(str, target)`',
    topic: 'validation',
    description: 'String ends with target.',
    return_type: 'boolean'
}, {
    title: '`isEquals(str, elem)`',
    topic: 'validation',
    description: 'Compares the two strings entered.',
    return_type: 'boolean'
}, {
    title: '`isHexaDecimal(str)`',
    topic: 'validation',
    description: 'String is hexadecimal.',
    return_type: 'boolean'
}, {
    title: '`isHexColor(str)`',
    topic: 'validation',
    description: 'String is a hex color.',
    return_type: 'boolean'
}, {
    title: '`isIPAddress(str)`',
    topic: 'validation',
    description: 'String is an IP address.',
    return_type: 'boolean'
}, {
    title: '`isLowerCase(str)`',
    topic: 'validation',
    description: 'String is all lower-cased.',
    return_type: 'boolean'
}, {
    title: '`isMACAddress(str)`',
    topic: 'validation',
    description: 'String is a MAC Address.',
    return_type: 'boolean'
}, {
    title: '`isMD5(str)`',
    topic: 'validation',
    description: 'String is a a MD5 type.',
    return_type: 'boolean'
}, {
    title: '`isPalindrome(str)`',
    topic: 'validation',
    description: 'String is a palindrome.',
    return_type: 'boolean'
}, {
    title: '`isUpperCase(str)`',
    topic: 'validation',
    description: 'String is all upper-cased.',
    return_type: 'boolean'
}, {
    title: '`isValidEmail(str)`',
    topic: 'validation',
    description: 'String is a valid email id.',
    return_type: 'boolean'
}];

module.exports = funcs;